#!/bin/sh
# Reduce Resource Consumption
su -c "cmd settings put system air_motion_engine 0"
su -c "cmd settings put system air_motion_wake_up 0"
su -c "cmd settings put global activity_starts_logging_enabled 0"
su -c "cmd settings put global ble_scan_always_enabled 0"
su -c "cmd settings put global hotword_detection_enabled 0"
su -c "cmd settings put global mobile_data_always_on 0"
su -c "cmd settings put global network_recommendations_enabled 0"
su -c "cmd settings put global wifi_scan_always_enabled 0"
su -c "cmd settings put secure adaptive_sleep 0"
su -c "cmd settings put secure screensaver_activate_on_dock 0"
su -c "cmd settings put secure screensaver_activate_on_sleep 0" 
su -c "cmd settings put secure screensaver_enabled 0"
su -c "cmd settings put secure send_action_app_error 0"
su -c "cmd settings put system intelligent_sleep_mode 0"
su -c "cmd settings put system master_motion 0"
su -c "cmd settings put system motion_engine 0"
su -c "cmd settings put system nearby_scanning_enabled 0"
su -c "cmd settings put system nearby_scanning_permission_allowed 0"
su -c "cmd settings put system rakuten_denwa 0"
su -c "cmd settings put system send_security_reports 0"

#Gms
su -c "pm disable com.google.android.gms/.chimera.GmsIntentOperationService"
su -c "pm disable  com.google.android.gms/com.google.android.gms.auth.managed.admin.DeviceAdminReceiver"
su -c "pm disable  com.google.android.gms/com.google.android.gms.mdm.receivers.MdmDeviceAdminReceiver"
dumpsys deviceidle whitelist -com.google.android.gms

# Stop Tombstoned
su -c "stop tombstoned"
su -c "am kill tombstoned"
su -c "killall -9 tombstoned"
su -c "pm disable com.android.shell.tombstoned"
echo "100" > /proc/sys/vm/swappiness
echo "0" > /sys/module/lowmemorykiller/parameters/enable_adaptive_lmk
echo "0" > /proc/sys/vm/overcommit_ratio
echo "100" > /proc/sys/vm/vfs_cache_pressure
echo "29615" > /proc/sys/vm/extra_free_kbytes
echo "256" > /proc/sys/kernel/random/read_wakeup_threshold
echo "256" > /proc/sys/kernel/random/write_wakeup_threshold
echo "2048" > /sys/block/mmcblk0/queue/read_ahead_kb
echo "0" > /sys/block/mmcblk0/queue/iostats
echo "1" > /sys/block/mmcblk0/queue/add_random
echo "2048" > /sys/block/mmcblk1/queue/read_ahead_kb
echo "0" > /sys/block/mmcblk1/queue/iostats
echo "1" > /sys/block/mmcblk1/queue/add_random
echo "4096" > /proc/sys/vm/min_free_kbytes
echo "0" > /proc/sys/vm/oom_kill_allocating_task
echo "40" > /proc/sys/vm/dirty_ratio
echo "10" > /proc/sys/vm/dirty_background_ratio
chmod 666 /sys/module/lowmemorykiller/parameters/minfree
chown root /sys/module/lowmemorykiller/parameters/minfree
echo "20949,27932,34915,76813,104745,111728" > /sys/module/lowmemorykiller/parameters/minfree

if [[ ! $(cmd -l | grep activity) ]]; then
echo "Not Supported"
exit
fi

sleep 2

for app in $(cmd package list packages -3 | cut -f 2 -d ":"); do
if [[ ! "$app" == "me.piebridge.brevent" ]] && \
   [[ ! "$app" == "eu.sisik.hackendebug" ]] && \
   [[ ! "$app" == "com.whatsapp" ]] && \
   [[ ! "$app" == "com.omarea.vtools" ]] && \
   [[ ! "$app" == "com.miHoYo.GenshinImpact" ]] && \
   [[ ! "$app" == "com.dts.freefiremax" ]] && \
   [[ ! "$app" == "com.dts.freefireth" ]] && \
   [[ ! "$app" == "com.tencent.ig" ]] && \
   [[ ! "$app" == "com.mobile.legends" ]]; then
   echo "Force stop $app"
   cmd activity force-stop "$app"
   sleep 1
   echo ""
fi
done

